https://leetcode-cn.com/problems/two-sum

一 题目

给定一个整数数组 nums 和一个整数目标值 target,请你在该数组中找出 和为目标值 target 的那 两个 整数,并返回它们的数组下标。你可以假设每种输入只会对应一个答案。但是,数组中同一个元素在答案里不能重复出现。你可以按任意顺序返回答案。

示例 1: 输入:nums = [2,7,11,15], target = 9 输出:[0,1]

解释:因为 nums[0] + nums[1] == 9 ,返回 [0, 1] 。

示例 2: 输入:nums = [3,2,4], target = 6

输出:[1,2]

示例 3: 输入:nums = [3,3], target = 6

输出:[0,1]

提示: 2 <= nums.length <= 104 -109 <= nums[i] <= 109 -109 <= target <= 109 只会存在一个有效答案 进阶:你可以想出一个时间复杂度小于 O(n2) 的算法吗?

二 暴力解法

image.png

  1. package top.black.leetcode.s0001twosum;
  2. public class Solution1 {
  3. /** 解法思路:
  4. * 直接使用双指针向后遍历
  5. * 计算两个指针所指位置的数相加是否等于 target
  6. * */
  7. public int[] twoSum(int[] nums, int target) {
  8. int tagB = 0;
  9. while(tagB<nums.length-1){
  10. int tagC = tagB+1;
  11. while(tagC<nums.length){
  12. if(nums[tagB]+nums[tagC]==target){
  13. return new int[]{tagB,tagC};
  14. }
  15. tagC++;
  16. }
  17. tagB++;
  18. }
  19. return null;
  20. }
  21. }

二 使用Hash表一次遍历

image.png

  1. package top.black.leetcode.s0001twosum;
  2. import java.util.HashMap;
  3. public class Solution2 {
  4. /** 使用Hash表
  5. * 遍历数组中的元素 numA ,计算 numB = target - numA
  6. * 再到Hash表中查看是否存在 numB
  7. * 如果存在,则取出 key = numB,value= 数组中的下标。
  8. * 如果不存在,则将 numA作为key,numA下标作为值存入Hash表中
  9. * */
  10. public int[] twoSum(int[] nums, int target) {
  11. HashMap<Integer, Integer> map = new HashMap<Integer, Integer>();
  12. for(int i = 0;i<nums.length;i++){
  13. int numA = nums[i];
  14. int numB = target - numA;
  15. if(map.containsKey(numB)){
  16. int tagB = map.get(numB);
  17. return new int[]{tagB,i};
  18. }else{
  19. map.put(numA,i);
  20. }
  21. }
  22. return null;
  23. }
  24. }